<template>
  <LayoutMain>
    <section>
      <b-container>
        <b-row align-h="center">
          <b-col cols="12">
            <TitleShape title="Gestión de categorías" />
          </b-col>
        </b-row>
      </b-container>
      <div class="color-wrapper">
      <b-container>
        <b-row class="text-right">
          <b-col cols="12">
          <router-link :to="{ name: 'admin.game.category.create' }" v-slot="{ href, navigate }" >
            <a :href="href" @click="navigate" class="btn btn-primary">Crear categoría
              </a>
          </router-link>
          </b-col>
        </b-row>
        <b-row align-h="center">
          <b-col cols="12">
            <b-table :items="itemsProvider" :busy="isLoading" class="mt-3" outlined id="category-table" :current-page="currentPage"
            :per-page="perPage" :fields="fields" :sort-by.sync="sortBy" :sort-desc.sync="sortDesc">
              <template #table-busy>
                <div class="text-center text-danger my-2">
                  <b-spinner class="align-middle"></b-spinner>
                  <strong>Loading...</strong>
                </div>
              </template>
              <template #cell(cards_actions)="row">                
                <router-link :to="{ name: 'admin.game.category.card.index', params: { category_id: row.item.id } }" v-slot="{ href, navigate }" >
                  <a :href="href" @click="navigate" class="" title="Gestionar cartas de categoría">
                    <eva-icon name=layers-outline width="1.5rem" height="1.5rem" animation="pulse" fill="#262535"></eva-icon>
                    </a>
                </router-link>
              </template>
              <!-- COLUMNA DE EDICION -->
              <template #cell(actions)="row">                
                <!-- BOTON EDITAR -->
                <router-link :to="{ name: 'admin.game.category.edit', params: { category_id: row.item.id } }" v-slot="{ href, navigate }" >
                  <a :href="href" @click="navigate" class="mr-3" title="Editar categoría">
                    <eva-icon name=edit-2-outline width="1.5rem" height="1.5rem" animation="pulse" fill="#262535"></eva-icon>
                  </a>
                </router-link>
                <!-- BOTON BORRAR -->
                <a href="#" @click="showDeleteModal(row.item, row.index, $event.target)" title="Borrar categoría">
                    <eva-icon name=trash-2-outline width="1.5rem" height="1.5rem" animation="pulse" fill="#262535"></eva-icon>
                </a>               
                
                <!-- INFOMODAL -->
              </template>
            </b-table>
             <b-pagination 
              v-model="currentPage"
              :total-rows="rows"
              :per-page="perPage"
              aria-controls="category-table"
            ></b-pagination>
          </b-col>
        </b-row>

        <b-modal :id="deleteModal.id" :title="deleteModal.title" @hidden="resetDeleteModal" @ok="handleDelete">    
          Confirma para eliminar la categoría {{deleteModal.item.title}}
        </b-modal>
      </b-container>
      </div>
    </section>
    <b-container class="mt-3">
      <b-row>
          <b-col cols="6">
            <b-button size="lg" v-on:click="$router.go(-1)" variant="secondary" >Volver</b-button>
          </b-col>
      </b-row>
    </b-container>
  </LayoutMain>
</template>

<script>
// @ is an alias to /src
import LayoutMain from "@/components/layouts/Main.vue";
import TitleShape from "@/components/TitleShape.vue";
import SingleSpecial from "@/components/SingleSpecial.vue";
import { mapState, mapGetters } from "vuex";

export default {
  name: "acount",
  components: {
    LayoutMain,
    TitleShape,
    SingleSpecial
  },
  data() {
      return {
        rows: null,
        categories: [],
        perPage: 15,
        currentPage: 1,
        sortBy: 'title',
        sortDesc: false,
        fields: [
          { key: 'id', label: 'id', sortable: true},
          { key: 'title', label: 'Título', sortable: true},
          { key: 'cards_count', label: 'Nº  Cartas', class: 'text-center', sortable: true},
          { key: 'updated_at', label: 'Actualizado', sortable: true, 
            formatter: (value, key, item) => {
              return new Date(value).toISOString()
            }
          },
          { key: 'cards_actions', label: 'Cartas', class: 'text-center' },
          { key: 'actions', label: 'Acciones', class: 'text-center' },          
        ],
        deleteModal: {
          id: 'delete-modal',
          title: '',
          item: ''
        }
      }
  },
  computed: {
    //Mapeo los getters del módulo auth para poder emplear sus funciones.
    ...mapGetters("category", ["isLoading"])
  },
  methods: {
    itemsProvider(ctx, callback) { // <- callback needs to be added here
      let page =  ctx.currentPage
      let perPage =  ctx.perPage
      let id = this.category_id
      let sortBy = ctx.sortBy
      let sortDesc = ctx.sortDesc
      let filter = ctx.filter    
      this.$store.dispatch('category/index', {page, perPage, sortBy, sortDesc}).then(resp => {
        const items = resp.data
        this.rows = resp.meta.total
        this.perPage = resp.meta.per_page
        this.currentPage = resp.meta.current_page
        callback(items)
      }).catch(error => {
        callback([])
      });
      return null
    },
    //INFOMODAL
    showDeleteModal(item, index, button) {
        this.deleteModal.title = 'Borrar categoría'
        this.deleteModal.item = item
        this.$root.$emit('bv::show::modal', this.deleteModal.id, button)
      },
      //NO CREO QUE SEA NECESARIO
      resetDeleteModal() {
        this.deleteModal.title = ''
        this.deleteModal.item = ''
      },
      handleDelete(bvModalEvt) {        
        // Prevent modal from closing
        bvModalEvt.preventDefault()    
        this.$store.dispatch('category/delete', {id: this.deleteModal.item.id}).then(resp => {
          this.$bvModal.hide(this.deleteModal.id)
           this.$root.$bvToast.toast('Categoría eliminada con éxito', {
            title: 'Eliminado',
            autoHideDelay: 5000,
            variant: 'success'
          })    
          this.$root.$emit('bv::refresh::table','category-table')       
        }).catch(error => {
          this.$bvModal.hide(this.deleteModal.id)
          this.$root.$bvToast.toast(error.message, {
            title: 'Eliminado',
            autoHideDelay: 5000,
            variant: 'error'
          })
        })
        console.log('bvvbnvbnvnvnb');
      }
  }
};
</script>

<style lang="scss">

@import '@/assets/custom-vars.scss';


</style>